﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace tThread
{
    public class MyThread1
    {
        //通知一个或多个正在等待的线程已发生事件
        ManualResetEvent mre = new ManualResetEvent(false);
        //服务器的运行标识
        bool isRuning = true;
        //线程安全的队列
        System.Collections.Concurrent.ConcurrentQueue<string> cqueue = new System.Collections.Concurrent.ConcurrentQueue<string>();

        public MyThread1()
        {
            Thread t = new Thread(RunTest);
            t.Name = "我是测试线程";
            t.Start();
        }

        //模拟新增任务
        public void add(int i)
        {
            //添加任务到队列
            cqueue.Enqueue("" + i);
            //唤醒所有相关的挂起线程
            mre.Set();
        }


        static void Main(string[] args)
        {
            MyThread1 p = new MyThread1();
            for (int i = 0; i < 10; i++)
            {
                p.add(i);
            }
            Console.ReadLine();
        }

        void RunTest()
        {
            //主循环 服务器运行标识
            while (isRuning)
            {
                //如果是空则继续等待      服务器运行标识
                while (cqueue.IsEmpty && isRuning)
                {
                    Console.WriteLine(DateTime.Now.ToString("HH:mm:ss:ffff") + " : " + Thread.CurrentThread.Name + "  sleep");
                    //重置线程暂停状态
                    mre.Reset();
                    //这个操作是以便服务器需要停止操作，
                    //如果停止调用线程的Thread.Abort()是会导致处理队列任务丢失
                    mre.WaitOne(2000);
                }
                string ret;
                //取出队列任务
                if (cqueue.TryDequeue(out ret))
                {
                    //测试输出任务
                    Console.WriteLine(DateTime.Now.ToString("HH:mm:ss:ffff") + " : " + Thread.CurrentThread.Name + "  " + ret);
                }
            }
        }
    }
}
