﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace tThread
{
    public class MyThread3
    {
        //通知一个或多个正在等待的线程已发生事件
        ManualResetEvent mre = new ManualResetEvent(false);
        //服务器的运行标识
        bool isRuning = true;
        //线程安全的队列
        System.Collections.Concurrent.ConcurrentQueue<string> cqueue = new System.Collections.Concurrent.ConcurrentQueue<string>();
        //计数存储器
        Dictionary<string, int> cdic = new Dictionary<string, int>();

        public MyThread3()
        {
            List<Thread> ts = new List<Thread>();
            for (int i = 0; i < 4; i++)
            {
                Thread t = new Thread(RunTest);
                t.Name = "我是线程（" + i + "）";
                cdic[t.Name] = 0;
                t.Start();
                ts.Add(t);
            }
        }

        //模拟新增任务
        public void Add()
        {
            Thread t1 = new Thread(() =>
            {
                for (int i = 0; i < 40; i++)
                {
                    //添加任务到队列
                    cqueue.Enqueue("日志记录 " + i);
                    //唤醒所有相关的挂起线程
                    mre.Set();
                }

            });
            t1.Start();

        }

        //输出计数器
        public override string ToString()
        {
            foreach (var item in cdic)
            {
                Console.WriteLine(item.Key + " 计数 " + item.Value);
            }
            return "";
        }


        static void Main(string[] args)
        {
            MyThread3 p = new MyThread3();
            p.Add();
            Console.ReadLine();
            p.ToString();
            Console.WriteLine();
            Console.ReadLine();
        }

        void RunTest()
        {
            //主循环 服务器运行标识
            while (isRuning)
            {
                //如果是空则继续等待      服务器运行标识
                while (cqueue.IsEmpty && isRuning)
                {
                    //重置线程暂停状态
                    mre.Reset();
                    //这个操作是以便服务器需要停止操作，
                    //如果停止调用线程的Thread.Abort()是会导致处理队列任务丢失
                    mre.WaitOne(2000);
                    Console.WriteLine(DateTime.Now.ToString("HH:mm:ss:ffff") + " : " + Thread.CurrentThread.Name + "  sleep");
                }
                string ret;
                //取出队列任务
                if (cqueue.TryDequeue(out ret))
                {
                    //测试输出任务
                    Console.WriteLine(DateTime.Now.ToString("HH:mm:ss:ffff") + " : " + Thread.CurrentThread.Name + "  " + ret);
                    //添加任务的计数器，为了查看最后线程执行任务的计数
                    cdic[Thread.CurrentThread.Name] = cdic[Thread.CurrentThread.Name] + 1;
                }
            }
        }
    }
}
